local _, addon = ...

function addon:DisplayTooltip(tooltip)
	local name, standing, repValue, repMax, percent, toGo, toGoPercent = self:GetWatchedFactionInfo()
	
	tooltip:ClearLines()	
	tooltip:AddLine(self.name, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, 1)
	tooltip:AddLine(" ")
	
	if name then
		tooltip:AddDoubleLine(format("%s (%s):", name, standing), format("|cffffffff%s / %s (%d%%)|r", repValue, repMax, percent))
		tooltip:AddDoubleLine("To go: ", format("|cffffffff%s (%d%%)|r", toGo, toGoPercent))
	else
		tooltip:AddLine("No faction was selected to watch for reputation.")
	end
	
	tooltip:Show()
end

function addon:GetTitle()
	local name, standing, repValue, repMax, percent = self:GetWatchedFactionInfo()
	
	if name and name ~= self.factionName then
		for i = 1, GetNumFactions() do
			if name == GetFactionInfo(i) then
				self.index = i
				self.factionName = name
			end
		end
	end
	
	if name then
		if percent ~= 100 then
			text = format("%s: %d / %d (%d%%)", name, repValue, repMax, percent)
		else
			text = format("%s (%s)", name, standing)
		end
	else
		text =  "N/A"
	end
	
	return text
end