local addonName, addon = ...
local core = CreateFrame("Frame")

addon.name = addonName:gsub("Broker_", "")

core:RegisterEvent("PLAYER_LOGIN")
core:RegisterEvent("UPDATE_FACTION")
local function onEvent(self, event, ...)
	if self[event] and type(self[event]) == "function" then
		self[event](self, event, ...)
	end
end
core:SetScript('OnEvent', onEvent)

local class = select(2, UnitClass("player"))
local label = ConvertRGBtoColorString(RAID_CLASS_COLORS[class])  .. "Reputation|r" 

function core:PLAYER_LOGIN()
	addon.dataobj = LibStub("LibDataBroker-1.1"):NewDataObject(addon.name, {
		type = "data source",
		label = label,
		text = addon:GetTitle(),
		OnClick = function(self, button)
			if IsModifierKeyDown() then
				addon:Paste(addon.index)
			else
				PanelTemplates_Tab_OnClick(CharacterFrameTab3, CharacterFrame);
				ToggleCharacter("ReputationFrame")
			end
		end,
		OnTooltipShow = function(self)
			addon:DisplayTooltip(self)
		end,
	})
end

function core:UPDATE_FACTION()
	if addon.dataobj then
		addon.dataobj.text = addon:GetTitle()
	end
end